import { Component, OnInit, ViewChild } from '@angular/core';
import { STComponent, STColumn, STChange } from '@delon/abc/st';
import { SFComponent, SFSchema } from '@delon/form';
import { NzModalService } from 'ng-zorro-antd/modal';
import { SystemService } from 'src/app/routes/sys-setting/services/system.service';

@Component({
  selector: 'app-etc-blacklist',
  templateUrl: './etc-blacklist.component.html',
  styleUrls: ['./etc-blacklist.component.less']
})
export class ETCBlacklistComponent implements OnInit {
  @ViewChild('st', { static: true })
  st!: STComponent;
  @ViewChild('sf', { static: false })
  sf!: SFComponent;
  tabs = [
    {
      name: '货主',
      type: 1,
      isActived: false
    },
    {
      name: '车辆',
      type: 2,
      isActived: false
    }
  ];
  tabType = 1;
  url = `/rule?_allow_anonymous=true`;

  searchSchema: SFSchema = {
    properties: {
      tabType: {
        type: 'number',
        ui: {
          hidden: true
        }
      },
      params1: {
        title: '企业名称',
        type: 'string',
        ui: {
          placeholder: '请输入',
          visibleIf: {
            tabType: (value: number) => this.tabType === 1
          }
        }
      },
      params2: {
        title: '联系人姓名',
        type: 'string',
        ui: {
          placeholder: '姓名/手机/车牌号',
          visibleIf: {
            tabType: (value: number) => this.tabType === 1
          }
        }
      },
      params3: {
        title: '手机号',
        type: 'string',
        ui: {
          placeholder: '请输入',
          visibleIf: {
            tabType: (value: number) => this.tabType === 1
          }
        }
      },
      params4: {
        title: '车牌号',
        type: 'string',
        ui: {
          placeholder: '请输入',
          visibleIf: {
            tabType: (value: number) => this.tabType === 2
          }
        }
      },
      params5: {
        title: '司机姓名',
        type: 'string',
        ui: {
          placeholder: '请输入',
          visibleIf: {
            tabType: (value: number) => this.tabType === 2
          }
        }
      },
      params6: {
        title: '手机号',
        type: 'string',
        ui: {
          placeholder: '请输入',
          visibleIf: {
            tabType: (value: number) => this.tabType === 2
          }
        }
      }
    }
  };

  columns: STColumn[] = [
    { title: '', index: 'key', type: 'checkbox' },
    { title: '企业名称', index: 'no', iif: () => this.tabType === 1 },
    { title: '联系人姓名', index: 'no', iif: () => this.tabType === 1 },
    { title: '车牌号', index: 'no', iif: () => this.tabType === 2 },
    { title: '司机姓名', index: 'no', iif: () => this.tabType === 2 },
    { title: '手机号', index: 'no' },
    {
      title: '认证状态',
      className: 'text-center',
      index: 'status',
      type: 'badge',
      badge: {
        0: { text: '启用', color: 'success' },
        2: { text: '禁用', color: 'error' },
        3: { text: '禁用', color: 'error' },
        1: { text: '禁用', color: 'error' }
      }
    },
    { title: '创建者', index: 'no' },
    {
      title: '创建时间',
      index: 'updatedAt',
      type: 'date'
    },
    {
      title: '操作',
      buttons: [
        {
          text: '删除',
          click: item => this.deleteAction(item)
        }
      ]
    }
  ];

  selectedRows: any[] = [];

  reqParams = { pageIndex: 1, pageSize: 10 };

  constructor(public service: SystemService, private nzModalService: NzModalService) {}

  ngOnInit(): void {}

  // 切换Tab
  changeTab(item: any) {
    this.tabType = item.type;
    this.sf?.setValue('/tabType', item.type);
    this.sf?.reset();
    setTimeout(() => {
      this.tabs.forEach(i => (i.isActived = false));
      item.isActived = !item.isActived;
      this.st.load(1);
      this.st.resetColumns();
    }, 500);
  }

  stChange(e: STChange): void {
    switch (e.type) {
      case 'checkbox':
        this.selectedRows = e.checkbox!;
        break;
      case 'filter':
        this.st.load();
        break;
    }
  }

  configAction(item?: any) {}

  deleteAction(item?: any) {
    this.nzModalService.error({
      nzTitle: '确认删除？',
      nzClosable: false,
      nzCancelText: '取消',
      nzOnOk: () => {}
    });
  }
  /**
   * 重置表单
   */
  resetSF() {
    this.sf.reset();
  }
}
